	title	Tall Tree Systems QDRIVE
	page	60,132
;@#$ c o ;
;************************************************
;*  	           QDRIVE 2.50			*
;*   Copyright(c)1983,1984 Tall Tree Systems	*
;************************************************

; 2.01 6/1/83	listing in manual
; 2.02 6/14/83	serial # added at 0012h
; 2.03 6/29/83	drivetec fixes at 027ah,045fh,079bh
; 2.04 7/1/83	quad and oquad fixes at 360h,370h
; 2.05 7/12/83	i3740 drive sensing at 46dh
;		retry fix at 592h
; 2.06 8/2/83	drivetec fixes at 5b4h,710h-728h
;		fdual fix at 126h
; 2.07 8/13/83	i3740 >32k file fix at 2d2h
;		drivetec fix at 496h
; 2.08 10/14/83	step rates at 2b0h,drivetec 512 sec
;		repeat formating,lnw patch/in
; 2.09 11/22/83 lnw patch fix/step rate fix/fdual at 12b
; 2.10 2/20/84	install init options, move dma buff if
;		64k bound,add drivetec patch, ratetab
; 		added ver# print out, amlyn
; 2.12 4/15/84	amlyn & drivetec fixes
; 2.14 5/28/84	error retry logic change+drivetec mode
; 2.15 7/29/84	fix 2.14 bug with dual9 on dual drive
; 2.20 9/20/84	fix retry logic
; 2.30 10/6/84	j,p&v formats,dr typ 4,mot on media ck
; 2.40 10/18/84	fix clk switch problem on teac FD55GF
; 2.50 2/24/85	allow dos 3 backups, reset change

; written for Tall Tree Systems by John Henderson
;		      2.10 mods by Hugh Macdonald

abs0	segment at 0
	org	0

; diskette parmeter table defs - bios parm block 1st

secsz	equ	0	;sector size in bytes
secalo	equ	2	;sectors/allocation unit
secres	equ	3	;boot sectors 
fatnum	equ	5	;num of fat copies
dircnt	equ	6	;num of dir entries
maxsec	equ	8	;no of sectors
media	equ	10	;media descriptor byte
fatsec	equ	11	;num sec each fat table

; optional 3 words added to boot sector

sectrk	equ	13	;sectors/track
heads	equ	15	;number of heads
hidden	equ	17	;hidden sectors

; floppy control parms

cyl	equ	19	;number of cylinders
ftype	equ	21	;diskette type letter
stepcmd	equ	22	;step rate
moton	equ	23	;motor start delay
motoff	equ	24	;motor off delay
settle	equ	25	;millisec head settle
secgap	equ	26	;header-sector gap len
hdrgap	equ	27	;sector-header gap len
fill	equ	28	;fill byte for format
secszx	equ	29	;0=128 1=256 2=512 3=1024
steps	equ	30	;multistep pulses
mfm	equ	31	;mfm = 40h

; Commom data area shared by intr 13h driver in proms

	org	78h
basvec	dd	0	;disk parm block ptr
	org	43eh
skstat	db	0	;drive recalc status
mostat	db	0	;motor status
mocnt	db	0	;time out ctr for drv turn off
dkstat	db	0	;ret code info for status
retstat	db	7 dup(0) ;7 status bytes from 8272

; error ret codes as per page 14-14 dos 2.00 manual
; note: dewrpro is returned as 0 value as per manual

dewrpro	equ	1	;write protect error
denordy	equ	2	;not ready error
decrc	equ	4	;data crc error
deseek	equ	6	;seek error
desec	equ	8	;sector not found error
defail	equ	12	;general failure error

abs0	ends

cseg	segment para public 'code'

qdrive	proc	far
	assume	cs:cseg,es:abs0,ds:cseg
begin:
start	equ	$

; request header equates

rh	equ	0	;request header
unit	equ	1	;unit # (0-3)
rhcmd	equ	2	;cmd code (dos pg 14-12)
rhstat	equ	3	;drive return status
dta	equ	0eh	;disk transfer area
count	equ	12h	;byte/sec count
ssn	equ	14h	;starting sector number

; equates media check

retbyt	equ	0eh	;byte returned from driver

; equates makbpb

baptr	equ	12h	;ptr to bpb

; equates init

units	equ	0dh	;num of drives
bradr0	equ	0eh	;next break adr offset
bradr1	equ	10h	;next break adr segment
bpboff	equ	12h	;bios parm block offset
bpbseg	equ	14h	;bios parm block segment

; special device header (see pg 14-5 dos 2 man)

nxtdev	dd	-1	;ptr to next dev
attrib	dw	800h	;block device/rm
strat	dw	qstrat	;ptr to device strategy
intr	dw	qintr	;ptr to device interrupt handler
nodrv	db	4	;number of block devices (units)
	db	'QDRIVE.';7 dup(0)
serno	db	'000001',0
copyw	db	'Copyright(c)1983,84,85 Tall Tree Systems',0

; bpb plus additonal info for each type of diskette format

	org	40h
single	dw	512	;single format diskette (s)
	db	1	;sec/cluster
	dw	1	;1 reserved sec
	db	2	;2 fat copies
	dw	64	;4 dir secs
	dw	320	;number sec
	db	0feh	;media descriptor byte
	dw	1	;num sec each fat table
	dw	8	;sec/trk
	dw	1	;num heads
	dw	0	;hidden sectors
	dw	40	;num cylinders
	db	's'	;format id
	db	1	;step rate select
	db	6	;1.4 sec motor start time
	db	37	;2 sec motor off delay
	db	0	;head settle time
	db	42	;header-sector gap
	db	80	;sector-header gap
	db	0f6h	;format fill byte
	db	2	;512 byte sectors
	db	1	;step multiplier
	db	40h	;mfm mode

usingle	dw	512	;9 sector single format (u)
	db	1	;sec/cluster
	dw	1	;1 reserved sec
	db	2	;2 fat copies
	dw	64	;4 dir secs
	dw	360	;num sec
	db	0fch	;media descriptor byte
	dw	2	;num sec each fat table
	dw	9	;sec/trk
	dw	1	;num heads
	dw	0	;hidden sectors
	dw	40	;num cylinders
	db	'u'	;format id
	db	1	;step rate select
	db	6	;1.4 sec motor start time
	db	37	;2 sec motor off delay
	db	0	;head settle time
	db	42	;header-sector gap
	db	80	;sector-header gap
	db	0f6h	;format fill byte
	db	2	;512 byte sectors
	db	1	;step multiplier
	db	40h	;mfm mode

tsingle	dw	512	;10 sector single format (t)
	db	1	;sec/cluster (2=optional)
	dw	1	;1 reserved sec
	db	2	;2 fat secs
	dw	112	;7 dir secs
	dw	400	;number secs
	db	0fah	;media descriptor byte
	dw	2	;num sec each fat table (1=option)
	dw	10	;sec/trk
	dw	1	;num heads
	dw	0	;hidden sectors
	dw	40	;num cylinders
	db	't'	;format id
	db	1	;step rate select
	db	6	;1.4 sec motor start time
	db	37	;2 sec motor off delay
	db	0	;head settle time
	db	24	;header-sector gap
	db	32	;sector-header gap
	db	0f6h	;format fill byte
	db	2	;512 byte sectors
	db	1	;step multiplier
	db	40h	;mfm mode

bsingle	dw	1024	;5 sector single format (b)
	db	1	;sec/cluster
	dw	1	;1 reserved sec
	db	2	;2 fat copies
	dw	96	;3 dir secs
	dw	200	;number secs
	db	0f8h	;media descriptor byte
	dw	1	;num sec each fat table
	dw	5	;sec/trk
	dw	1	;num heads
	dw	0	;hidden sectors
	dw	40	;num cylinders
	db	'b'	;format id
	db	1	;step rate select
	db	6	;1.4 sec motor start time
	db	37	;2 sec motor off delay
	db	0	;head settle time
	db	42	;header-sector gap
	db	80	;sector-header gap
	db	0f6h	;format fill byte
	db	3	;1024 byte sectors
	db	1	;step multiplier
	db	40h	;mfm mode

dual	dw	512	;dual format diskette (d)
	db	2	;sec/cluster
	dw	1	;1 reserved sec
	db	2	;2 fat copies
	dw	112	;7 dir secs
	dw	640	;number secs
	db	0ffh	;media descriptor byte
	dw	1	;num sec each fat table
	dw	8	;sec/trk
	dw	2	;num heads
	dw	0	;hidden sectors
	dw	40	;num cylinders
	db	'd'	;format id
	db	1	;step rate select
	db	6	;1.4 sec motor start time
	db	37	;2 sec motor off delay
	db	0	;head settle time
	db	42	;header-sector gap
	db	80	;sector-header gap
	db	0f6h	;format fill byte
	db	2	;512 byte sectors
	db	1	;step multiplier
	db	40h	;mfm mode

cdual	dw	512	;9 sector dual format (c)
	db	2	;sec/cluster
	dw	1	;1 reserved sec
	db	2	;2 fat copies
	dw	112	;7 dir secs
	dw	720	;number secs
	db	0fdh	;media descriptor byte
	dw	2	;num sec each fat table
	dw	9	;sec/trk
	dw	2	;num heads
	dw	0	;hidden sectors
	dw	40	;num cylinders
	db	'c'	;format id
	db	1	;step rate select
	db	6	;1.4 sec motor start time
	db	37	;2 sec motor off delay
	db	0	;head settle time
	db	42	;header-sector gap
	db	80	;sector-header gap
	db	0f6h	;format fill byte
	db	2	;512 byte sectors
	db	1	;step multiplier
	db	40h	;mfm mode

edual	dw	512	;10 sector dual format (e)
	db	1	;sec/cluster (.5k) [optional use 4]
	dw	1	;1 reserved sec
	db	2	;2 fat secs
	dw	144	;9 dir secs
	dw	800	;number secs
	db	0fbh	;media descriptor byte
	dw	3	;num sec each fat table [optional use 1]
	dw	10	;sec/trk
	dw	2	;num heads
	dw	0	;hidden sectors
	dw	40	;num cylinders
	db	'e'	;format id
	db	1	;step rate select
	db	6	;1.4 sec motor start time
	db	37	;2 sec motor off delay
	db	0	;head settle time
	db	24	;header-sector gap
	db	32	;sector-header gap
	db	0f6h	;format fill byte
	db	2	;512 byte sectors
	db	1	;step multiplier
	db	40h	;mfm mode

fdual	dw	1024	;5 sector dual format (f)
	db	1	;sec/cluster
	dw	1	;1 reserved sec
	db	2	;2 fat copies
	dw	160	;5 dir secs
	dw	400	;number sec
	db	0f9h	;media descriptor byte
	dw	1	;num sec each fat table
	dw	5	;sec/trk
	dw	2	;num heads
	dw	0	;hidden sectors
	dw	40	;num cylinders
	db	'f'	;format id
	db	1	;step rate select
	db	6	;1.4 sec motor start time
	db	37	;2 sec motor off delay
	db	0	;head settle time
	db	42	;header-sector gap
	db	80	;sector-header gap
	db	0f6h	;format fill byte
	db	3	;1024 byte sectors
	db	1	;step multiplier
	db	40h	;mfm mode

quad	dw	512	;quad format diskette (q)
	db	4	;sec/cluster
	dw	1	;1 reserved sec
	db	2	;2 fat copies
	dw	144	;9 dir secs
	dw	1280	;number secs
	db	0fdh	;media descriptor byte
	dw	1	;num sec each fat table
	dw	8	;sec/trk
	dw	2	;num heads
	dw	0	;hidden sectors
	dw	80	;num cylinders
	db	'q'	;format id
	db	1	;step rate select
	db	6	;1.4 sec motor start time
	db	37	;2 sec motor off delay
	db	0	;head settle time
	db	42	;header-sector gap
	db	80	;sector-header gap
	db	0f6h	;format fill byte
	db	2	;512 byte sectors
	db	1	;step multiplier
	db	40h	;mfm mode

oquad	dw	512	;9 sector quad format (o)
	db	4	;sec/cluster
	dw	1	;1 reserved sec
	db	2	;2 fat copies
	dw	144	;9 dir secs
	dw	1440	;number secs
	db	0fbh	;media descriptor byte
	dw	2	;num sec each fat table
	dw	9	;sec/trk
	dw	2	;num heads
	dw	0	;hidden sectors
	dw	80	;num cylinders
	db	'o'	;format id
	db	1	;step rate select
	db	6	;1.4 sec motor start time
	db	37	;2 sec motor off delay
	db	0	;head settle time
	db	42	;header-sector gap
	db	80	;sector-header gap
	db	0f6h	;format fill byte
	db	2	;512 byte sectors
	db	1	;step multiplier
	db	40h	;mfm mode

rquad	dw	512	;10 sector quad format (r)
	db	1	;sec/cluster  (optional use 8)
	dw	1	;1 reserved sec
	db	2	;2 fat copies
	dw	144	;9 dir sec
	dw	1600	;number sec
	db	0f9h	;media descriptor byte
	dw	5	;num sec each fat table (option use 1)
	dw	10	;sec/trk
	dw	2	;num heads
	dw	0	;hidden sectors
	dw	80	;num cylinders
	db	'r'	;format id
	db	1	;step rate select
	db	6	;1.4 sec motor start time
	db	37	;2 sec motor off delay
	db	0	;head settle time
	db	24	;header-sector gap
	db	32	;sector-header gap
	db	0f6h	;format fill byte
	db	2	;512 byte sectors
	db	1	;step multiplier
	db	40h	;mfm mode

nquad	dw	1024	;5 sector quad format (n)
	db	2	;sec/cluster (option use 1)
	dw	1	;1 reserved sec
	db	2	;2 fat copies
	dw	160	;5 dir sec
	dw	800	;number secs
	db	0fah	;media descriptor byte
	dw	1	;num sec each fat table (option use 2)
	dw	5	;sec/trk
	dw	2	;num heads
	dw	0	;hidden sectors
	dw	80	;num cylinders
	db	'n'	;format id
	db	1	;step rate select
	db	6	;1.4 sec motor start time
	db	37	;2 sec motor off delay
	db	0	;head settle time
	db	42	;header-sector gap
	db	80	;sector-header gap
	db	0f6h	;format fill byte
	db	3	;1024 byte sectors
	db	1	;step multiplier
	db	40h	;mfm mode

i3740	dw	128	;8" 26 sector format (i)
	db	4	;sec/alloc unit
	dw	1	;1 reserved sec
	db	2	;2 fat tables
	dw	68	;17 dir secs
	dw	2002	;number secs
	db	0feh	;media descriptor byte
	dw	6	;num sec each fat table
	dw	26	;sec/trk
	dw	1	;num heads
	dw	0	;hidden sectors
	dw	77	;num cylinders
	db	'i'	;format id
	db	0	;step rate select
	db	6	;1.4 sec motor start time
	db	37	;2 sec motor off delay
	db	12	;head settle time
	db	7	;header-sector gap
	db	27	;sector-header gap
	db	0e5h	;format fill byte
	db	0	;128 byte sectors
	db	1	;step multiplier
	db	0	;df mode

large	dw	1024	;8 sector format (l)
	db	1	;sec/alloc unit
	dw	1	;1 reserved sec
	db	2	;2 fat tables
	dw	192	;6 dir secs
	dw	616	;number secs
	db	0feh	;media descriptor byte
	dw	1	;num sec each fat table
	dw	8	;sec/trk
	dw	1	;num heads
	dw	0	;hidden sectors
	dw	77	;num cylinders
	db	'l'	;format id
	db	1	;step rate select
	db	6	;1.4 sec motor start time
	db	37	;2 sec motor off delay
	db	14	;head settle time
	db	53	;header-sector gap
	db	116	;sector-header gap
	db	0e5h	;format fill byte
	db	3	;1024 byte sectors
	db	1	;step multiplier
	db	40h	;mfm mode

massive	dw	512	;16 sector format (m)
	db	2	;sec/alloc unit
	dw	1	;1 reserved sec
	db	2	;2 fat tables
	dw	176	;11 dir secs
	dw	1232	;number secs
	db	0fch	;media descriptor byte
	dw	2	;num sec each fat table
	dw	16	;sec/trk
	dw	1	;num heads
	dw	0	;hidden sectors
	dw	77	;num cylinders
	db	'm'	;format id
	db	1	;step rate select
	db	6	;1.4 sec motor start time
	db	37	;2 sec motor off delay
	db	14	;head settle time
	db	27	;header-sector gap
	db	58	;sector-header gap
	db	0e5h	;format fill byte
	db	2	;512 byte sectors
	db	1	;step multiplier
	db	40h	;mfm mode

giant	dw	1024	;8" 8 sector format (g)
	db	1	;sec/alloc unit
	dw	1	;1 reserved sec
	db	2	;2 fat tables
	dw	192	;6 dir sec
	dw	1232	;number secs
	db	0ffh	;media descriptor byte
	dw	2	;num sec each fat table
	dw	8	;sec/trk
	dw	2	;num heads
	dw	0	;hidden sectors
	dw	77	;num cylinders
	db	'g'	;format id
	db	1	;step rate select
	db	6	;1.4 sec motor start time
	db	37	;2 sec motor off delay
	db	14	;head settle time
	db	53	;header-sector gap
	db	116	;sector-header gap
	db	0e5h	;format fill byte
	db	3	;1024 byte sectors
	db	1	;step multiplier
	db	40h	;mfm mode

; Thanks to Clyde Washburn of Earth Terminals

wash	dw	512	;8" 16 sector format (w)
	db	2	;sec/alloc unit
	dw	1	;1 reserved sec
	db	2	;2 fat tables
	dw	176	;11 dir sec
	dw	2464	;number secs
	db	0fdh	;media descriptor byte
	dw	4	;num sec each fat table
	dw	16	;sec/trk
	dw	2	;num heads
	dw	0	;hidden sectors
	dw	77	;num cylinders
	db	'w'	;format id
	db	1	;step rate select
	db	4	;.933 sec motor start time
	db	37	;2 sec motor off delay
	db	14	;head settle time
	db	27	;header-sector gap
	db	58	;sector-header gap
	db	0e5h	;format fill byte
	db	2	;512 byte sectors
	db	1	;step multiplier
	db	40h	;mfm mode

huge	dw	512	;5" drivetec (really 256)(h)
	db	2	;sec/alloc unit
	dw	1	;1 reserved sec
	db	2	;2 fat tables
	dw	256	;16 dir secs
	dw	5440	;num sec
	db	0f8h	;media descriptor byte
	dw	8	;num sec each fat table
	dw	17	;sec/trk
	dw	2	;num heads
	dw	0	;hidden sectors
	dw	160	;num cylinders
	db	'h'	;format id
	db	1	;step rate select
	db	6	;1.4 sec motor start time
	db	37	;2 sec motor off delay
	db	12	;head settle time
	db	22	;header-sector gap
	db	12	;sector-header gap
	db	0e5h	;format fill byte
	db	2	;512 byte sectors
	db	1	;step multiplier
	db	40h	;mfm mode

awesome	dw	512	;5" 16 sector 154 trks (a)
	db	2	;sec/alloc unit (1 kbytes)
	dw	1	;1 reserved sec
	db	2	;2 fat tables
	dw	256	;8 dir secs
	dw	4928	;num sec
	db	0f8h	;media descriptor byte
	dw	8	;num sec each fat table
	dw	16	;sec/trk
	dw	2	;num heads
	dw	0	;hidden sectors
	dw	154	;num cylinders
	db	'a'	;format id
	db	1	;step rate select
	db	6	;1.4 sec motor start time
	db	37	;2 sec motor off delay
	db	12	;head settle time
	db	27	;header-sector gap
	db	58	;sector-header gap
	db	0e5h	;format fill byte
	db	2	;512 byte sectors
	db	1	;step multiplier
	db	40h	;mfm mode

jumbo	dw	512	;AT 15 sector format (j)
	db	1	;sec/alloc unit
	dw	1	;1 reserved sec
	db	2	;2 fat tables
	dw	224	;14 dir sec
	dw	2400	;number secs
	db	0f9h	;media descriptor byte
	dw	7	;num sec each fat table
	dw	15	;sec/trk
	dw	2	;num heads
	dw	0	;hidden sectors
	dw	80	;num cylinders
	db	'j'	;format id
	db	1	;step rate select
	db	6	;1.4 sec motor start time
	db	37	;2 sec motor off delay
	db	14	;head settle time
	db	27	;header-sector gap
	db	84	;sector-header gap
	db	0e5h	;format fill byte
	db	2	;512 byte sectors
	db	1	;step multiplier
	db	40h	;mfm mode

packed	dw	512	;teac 55gf 16 sector format (p)
	db	2	;sec/alloc unit
	dw	1	;1 reserved sec
	db	2	;2 fat tables
	dw	176	;11 dir sec
	dw	2560	;number secs
	db	0ffh	;media descriptor byte
	dw	4	;num sec each fat table
	dw	16	;sec/trk
	dw	2	;num heads
	dw	0	;hidden sectors
	dw	80	;num cylinders
	db	'p'	;format id
	db	1	;step rate select
	db	6	;1.4 sec motor start time
	db	37	;2 sec motor off delay
	db	14	;head settle time
	db	27	;header-sector gap
	db	58	;sector-header gap
	db	0e5h	;format fill byte
	db	2	;512 byte sectors
	db	1	;step multiplier
	db	40h	;mfm mode

verybig	dw	512	;mit 20 sector format (v)
	db	2	;sec/alloc unit
	dw	1	;1 reserved sec
	db	2	;2 fat tables
	dw	256	;16 dir sec
	dw	3200	;number secs
	db	0feh	;media descriptor byte
	dw	5	;num sec each fat table
	dw	20	;sec/trk
	dw	2	;num heads
	dw	0	;hidden sectors
	dw	80	;num cylinders
	db	'v'	;format id
	db	1	;step rate select
	db	6	;1.4 sec motor start time
	db	37	;2 sec motor off delay
	db	14	;head settle time
	db	27	;header-sector gap
	db	58	;sector-header gap
	db	0e5h	;format fill byte
	db	2	;512 byte sectors
	db	1	;step multiplier
	db	40h	;mfm mode

; local procedures variables (do not change order of vars)

bpbptr	dw	usingle	;array of bpb's
	dw	usingle	;drive 2
	dw	usingle	;drive 3
	dw	usingle	;drive 4
drvtyp	db	0,1,2,2	;0=single/dual,1=quad,2=8",3=drivetec
drvoff	db	0	;added to unit # to get bpbptr
ck128	db	0	;check for 128 sec size
ck512	db	1	;check for 512 sec size
ck1k	db	0	;check for 1024 sec size
rates	db	0afh,0dfh	;drive 1 6 ms (reset by init)
	db	0cfh,0efh	;drive 2 4 ms
	db	0afh,0dfh	;drive 3 3 millisec
	db	0afh,0dfh	;drive 4 3 millisec
ioport	dw	0		;port for setting clock rate
rate5	db	1		;5" clock rate (250k baud)
rate8	db	0		;8" clock rate (500k baud)
ratetab	db	0afh,0dfh	;type 0 (dual) 6 ms step rate
	db	0cfh,0efh	;type 1 (quad) 4 ms
	db	0afh,0dfh	;type 2 (8"  ) 3 ms
	db	0afh,0dfh	;type 3 (drivetec/amlyn) 3 ms
	db	0afh,0dfh	;type 4 (at your pc) 3 ms
	db	0afh,0dfh	;type 5 teac fd55g
cmd	db	0	;2=rd sec, 3=wr sec
verify	db	0	;1=verify after wr
seccnt	dw	0	;no of sec to xfr
rhoff	dw	0	;req hdr ptr offset
rhseg	dw	0	;req hdr ptr segment
savsp	dw	0	;system stack ptr save
savss	dw	0	;system stack segment save
savsp2	dw	0	;high level abort reload
savsp3	dw	0	;low level retry reload
secno	dw	0	;current sector no
nxtsec	dw	0	;2nd half xfr sec adr
retry	db	0	;r/w retry ctr
head	db	0	;floppy driver head #
secfat	dw	0	;total fat sec cnt
secdir	dw	0	;num of directory sectors
secdat	dw	0	;offset of 1st data sector
fatsiz	dw	0	;bytes in 1 fat table
dirsiz	dw	0	;bytes in whole directory
bufptr	dw	secbuf	;default dma buff loc
modtab	db	0,0,0,0	;current dmode for each drv
modptr	dw	modtab	;ptr to selected modtab
dtype	db	0	;selected drvtyp
dmsg	db	'drivetec mode'
dmode	db	0	;jdiskette 0c0h for 8"
dmask	db	0ffh	;jdiskette controller=3fh

; common routine to unload request header into regs

setxfr	proc	near
	push	es		;req header seg
	pop	ds
	mov	al,unit[bx]
	cbw
	mov	cx,count[bx]	;no sec to xfr
	mov	dx,ssn[bx]	;starting sec no
	mov	di,dta+2[bx]	;xfr segment
	mov	bx,dta[bx]	;xfr offset
	mov	es,di
	push	cs
	pop	ds
	add	al,[drvoff]	;maybe skip 1st drvs
	mov	si,offset modtab
	add	si,ax
	mov	[modptr],si
	xchg	ax,bp
	lodsb
	mov	[dmode],al
	mov	si,offset drvtyp
	add	si,bp
	lodsb
	mov	[dtype],al
	xchg	ax,bp
	mov	si,offset bpbptr
	add	si,ax
	add	si,ax
	mov	bp,[si]		;bp=ptr to bpb
	ret
setxfr	endp

; analyze fat byte & auto sense diskette type

makbpb:	mov	al,es:unit[bx]
	cbw
	add	al,[drvoff]
	mov	bp,offset bpbptr
	add	bp,ax
	add	bp,ax
makb10:	mov	dx,offset single ;modified @ inp30: & ck50:
	mov	[bp],dx		;save auto sense type
	call	setxfr
	mov	di,offset drvtyp
	add	di,ax		;ptr drv type 0,1,2,3
	mov	al,es:[bx]	;fat code
	cbw
	cmp	bp,offset single
	je	makb11
	jmp	makb20
makb11:	inc	ax
	mov	bp,offset dual		;ff
	jz	ckstep
	inc	ax
	mov	bp,offset single 	;fe
	jz	ckstep
	inc	ax
	mov	bp,offset cdual		;fd
	jz	ckfd
	inc	ax
	mov	bp,offset usingle 	;fc
	jz	ck8fc
	inc	ax
	mov	bp,offset edual		;fb
	jz	ckfb
	inc	ax
	mov	bp,offset tsingle 	;fa
	jz	ckstep
	inc	ax
	mov	bp,offset rquad		;f9
	jz	makb25
patcha:	mov	bp,offset huge		;f8 (drivetec)
	jmp	short makb30
ck8fc:	cmp	byte ptr[di],2		;type = 8"?
	jne	ckstep			;not 8" drive
	mov	bp,offset massive
	jmp	short makb30
ckfd:	cmp	byte ptr[di],2
	je	ck8fd			;8"
patch8:	jmp	short ckstep		;(patch q8 je ckstep)
	mov	bp,offset quad		;quad
	jmp	short makb25
ck8fd:	mov	bp,offset wash
	jmp	short makb30
ckfb:	cmp	byte ptr[di],1		;type = quad?
patch9:	jmp	short ckstep		;(patch q9 jb ckstep)
	mov	bp,offset oquad		;quad
makb25:	mov	byte ptr steps[bp],1	;default
	cmp	byte ptr[di],3
	je	makb29			;drivetec
	jmp	short makb30
ckstep:	test	byte ptr[di],1		;quad or drivetec?
	mov	byte ptr steps[bp],1	;step multiplier=1
	je	makb28			;dual or 8" drive
	shl	byte ptr steps[bp],1	;double step
makb28:	cmp	byte ptr[di],3		;drivetec/jdiskette?
	jb	makb30			;no
makb29:	shl	byte ptr steps[bp],1	;quad/double step
makb30:	mov	[si],bp			;update bpbptr
	pop	es			;pass bpb ptr to dos
	pop	bx
	mov	es:baptr[bx],bp
	mov	es:baptr+2[bx],cs
	jmp	short qdone
makb20:	cmp	bp,offset bsingle
	jne	makb40
	inc	ax
	mov	bp,offset giant		;ff
	je	makb30
	inc	ax
	mov	bp,offset large		;fe
	je	makb30
	inc	ax
	inc	ax
	inc	ax
	inc	ax
	mov	bp,offset nquad		;fa
	je	makb25
	inc	ax
	mov	bp,offset fdual		;f9
	je	ckstep
	mov	bp,offset bsingle 	;f8
	jmp	ckstep
makb40:	cmp	bp,offset jumbo
	jne	makb50
	inc	ax
	mov	bp,offset packed
	je	makb50			;fb
	inc	ax
	mov	bp,offset verybig
	je	makb50			;fe
	mov	bp,offset jumbo
makb50:	jmp	makb25

mediack:
	mov	al,es:unit[bx]
	add	al,cs:[drvoff]
	xchg	ax,cx
	mov	al,10h
	sal	al,cl
	push	ds
	xor	cx,cx
	mov	ds,cx
	assume	ds:abs0
	and	al,[mostat]
	assume	ds:cseg
	pop	ds
	je	medk10			;0=don't know
	mov	al,1			;1=no change
medk10:	mov	es:byte ptr retbyt[bx],al

dummy:
qexit:	pop	es		;restore req hdr ptr
	pop	bx		;saved on local stack
qdone:	or	es:word ptr rhstat[bx],100h ;set done
	cli
	mov	ss,cs:[savss]
	mov	sp,cs:[savsp]	;restore system stack
	sti
	pop	bp		;restore rest of dos regs
	pop	si
	pop	di
	pop	dx
	pop	cx
	pop	ax
	pop	ds
	ret			;far ret

remov:	and	cs:word ptr rhstat[bx],0fdffh ;clr busy=media remov
	jmp	short qexit

	assume	ds:cseg,es:cseg

; device strategy entry point (really does nothing)

qstrat:	mov	cs:[rhoff],bx
	mov	cs:[rhseg],es
	ret			;far ret

; device i/o software interrupt entry point

qintr:	cld
	push	ds		;save all registers
	push	ax
	push	cx
	push	dx
	push	di
	push	si
	push	bp
	mov	cs:[savsp],sp	;save at this point
	mov	cs:[savss],ss	;see pg 14-10 dos 2 man
	mov	ax,cs
	cli
	mov	ss,ax
	mov	sp,offset begsp	;switch to internal stack
	sti
	les	bx,dword ptr[rhoff]
	push	bx		;save ret code ptrs last
	push	es

	mov	al,es:rhcmd[bx] ;req hdr cmd code
	cbw
	shl	ax,1		;conv to word index
	mov	di,offset funtab
	add	di,ax
	jmp	cs:word ptr[di]

; command code field values from dos pg 14-12

funtab	label	byte
	dw	init	;initialization
	dw	mediack	;media ck
	dw	makbpb	;build bpb
	dw	dummy	;ioctl input
	dw	input	;input (read)
	dw	dummy	;non_destructive input no wait
	dw	dummy	;input status
	dw	dummy	;input flush
	dw	output	;output (write)
	dw	outver	;output (write) with verify
	dw	dummy	;output status
	dw	dummy	;output flush
	dw	dummy	;ioctl output
	dw	dummy	;open device
	dw	dummy	;close device
	dw	remov	;removable media

nopret:	jmp	qexit

input:	call	setxfr		;setup xfr regs
	cmp	dx,1		;ck for fat read
	jne	inp40
	cmp	cx,dx
	jne	inp40		;protect from jet
	cmp	[dtype],4	;teac fd55gf
	jb	inp15
	mov	bp,offset jumbo
	ja	inp30		;teac fd55g
	test	[dmode],0c0h	;hi density mode
	jne	inp30
inp15:	cmp	dh,[ck1k]
	je	inp20
	mov	bp,offset bsingle
	jmp	short inp30
inp20:	cmp	dh,[ck512]
	je	inp35
	mov	bp,offset single
	jmp	short inp30
inp35:	cmp	dh,[ck128]
	je	inp40
	mov	bp,offset i3740
inp30:	mov	word ptr [makb10+1],bp ;auto sense
inp40:	mov	ah,2		;dk rd
	jmp	short doboth
output:	call	setxfr		;setup xfr regs
	mov	[verify],0
	jmp	short dowr
outver:	call	setxfr		;setup xfr regs
	mov	[verify],1
dowr:	mov	ah,3		;dk wr
doboth:	mov	[savsp2],sp	;save for abort

; al = drive number		di = xfr segment
; bx = xfr adr (es seg)		bp = bpb ptr
; cx = sec cnt			dx = sec adr

	jcxz	nopret
	mov	[cmd],ah	;save r/w cmd byte
	cbw			;head=0
	push	ax		;save drive
	xchg	ax,dx		;restore sec adr
	xor	dx,dx
	div	word ptr sectrk[bp]	;dx=rem ax=quot 
	xchg	ax,dx		;dx=track # (0-320)
	inc	ax		;ax=sector # (1-sec/trk)
	cmp	byte ptr heads[bp],1
	jz	onehd
	shr	dx,1		;two sided drive
	mov	ah,dl
	pop	dx		;restore head/drive no
	rcl	dh,1
	jmp	short bothhd
onehd:	mov	ah,dl		;trk
	pop	dx		;restore head/drive no
bothhd:	or	ah,ah		;at trk zero
	jne	bywait
	cmp	[cmd],3		;wr cmd?
	jne	bywait
	push	cx
	xor	cx,cx
upto:	loop	upto		;1/8 sec for motor speed
	pop	cx
bywait:	xchg	cx,ax		;ch=trk cl=sec
	mov	[seccnt],ax
	shl	di,1		;ck for dma overflow
	shl	di,1
   	shl	di,1
	shl	di,1
	add	di,bx
	add	di,secsz[bp]	;add one sec size - 1
	jz	exact		;exact fit
	jc	secovr		;1st sec overflows
exact:	dec	di
	xchg	ax,di		;di=sec cnt
	push	dx
	not	ax		;ax=bytes left in bank
	xor	dx,dx
	div	word ptr secsz[bp] ;div by sec size
	xchg	ax,dx		;dx=sec left in bank
	inc	dx
	xchg	ax,di		;ax=sec cnt overall
	cmp	dx,ax		;left in bank vs to do
	mov	si,dx		;r/w all left in bank
	pop	dx
   	jbe	nocut
	mov	si,ax		;cut off # sec to r/w
nocut:	push	ax		;ax=# this time
	mov	ax,si		;ax=# to do
	push	di
	push	si
	call	rwseq		;r/w ahead of overflow
	pop	si
	pop	di
	pop	ax
	sub	ax,si		;ax=# left to do
	jz	qback		;no dma overflow

secovr:	cld
	or	di,di		;bytes to split
	je	align		;on boundry
	dec	ax		;num sec to r/w
	push	ax		;ax=sec left to do
	push	es		;dma seg
	push	bx		;dma adr
   	cmp	[cmd],3
	jz	wrovr

; disk read of overflow

	push	cs
	pop	es
	mov	bx,[bufptr]	;offset secbuf
	call	rwsec		;rd one sec
	mov	si,bx
	pop 	bx    		;dma adr
	pop	es		;dma seg
	push	cx
	mov	cx,secsz[bp]
	mov	di,bx
	rep	movsb
	pop	cx
	jmp	short aftovr

; disk write of overflow
 	
wrovr:	push	cx
   	mov	cx,secsz[bp]
	mov	si,bx
	mov	di,[bufptr]	;offset secbuf
	mov	bx,di
	push	es
	push	cs
	pop	es
	pop	ds
	rep	movsb
	pop	cx
        push	cs
 	pop	ds
	call	rwsec		;wr one sec
	pop	bx		;dma adr
	pop	es		;dma seg

; continue r/w after overflow sector

aftovr:	add	bx,secsz[bp]
	pop	ax		;ax=remaining sec cnt
align:	call	rwseq		;r/w sec aft overflow

; exit driver routines

qback:	jmp	qexit

; r/w sequence of sectors with track rwseq

rwseq	proc	near
	mov	si,ax		;# sec to r/w
again:	or	si,si		;left to do
	jz	rwret		;none left to r/w
	mov 	ax,sectrk[bp]
	inc	ax
	sub	al,cl		;sub starting sec adr
	cmp	ax,si		;left on trk vs to do
	jbe	dotrk
	mov	ax,si		;less than rest of trk
dotrk:	push	ax		;ax=this time si=overall
	push	si
	call	rwtry		;multi sec r/w
	pop	si
	pop	ax
	sub	si,ax		;sub done from to do
	push	dx
	mul	word ptr secsz[bp]
	pop	dx
	add	bx,ax		;update dma adr
	jmp	short again
rwseq	endp

; multi-sector disk r/w subroutines

rwsec	proc	near
	mov	al,1		;# of sec to r/w
rwsec	endp

rwtry	proc	near
	mov	ah,[cmd]
	mov	si,5		;retry ctr
cmdgo:	push	ax		;save cmd
	call	floppy		;do cmd
	jc	dkerr		;error occurred
	pop	ax		;restore cmd
	push	ax
	cmp	word ptr [cmd],0103h
	jnz	rwok
	mov	ah,4		;verify write
	call	floppy
	jc	dkerr		;error occurred

; process end of single multisector transfer

rwok:	pop	ax		;ah=cmd/al=sec cnt
	mov	ah,0
	sub	[seccnt],ax
	add	cl,al		;update sec adr
	cmp	cl,byte ptr sectrk[bp]	;sec/trk variable
	jbe	rwret
	mov	cl,1		;rollover track sec=1
	cmp	byte ptr heads[bp],cl
	jz	inctrk		;1 sided
	xor	dh,cl		;2 sided - flip head
	jnz	rwret
inctrk:	inc	ch		;inc trk adr
rwret:	ret
rwtry	endp

; process disk errors

dkerr:	cmp	ah,dewrpro
	jne	ck60
	dec	ah		;actual ret code
ck60:	xchg	ax,di		;save error code
	mov	al,6		;reset floppy dma
	out	10,al
	je	ck11		;dewrpro error once
	jmp	short ck66
	mov	ah,0		;reset 8272 while
	call	floppy		;setting new clk rate
ck66:	push	ds
	xor	ax,ax
	mov	ds,ax
	assume	ds:abs0
	mov	[dkstat],al
	mov	[skstat],al
	assume	ds:cseg
	pop	ds
	cmp	cx,2		;ck for fat sec read
	jne	cntdn
	cmp	dh,al
	jne	cntdn
	cmp	[cmd],2
	jne	cntdn
	cmp	[dtype],4	;teac fd55gf
	jne	ck70
	cmp	si,3
	jne	cntdn
	mov	bp,[modptr]
	xor	byte ptr[bp],0c0h ;flip density
	mov	al,[bp]
	mov	[dmode],al
	mov	bp,offset jumbo
	pushf
	mov	ah,0		;reset 8272 while
	call	floppy		;setting new clk rate
	popf
	jne	ck50		;try single
	jmp	short ck25	;try jumbo
ck70:	cmp	bp,offset i3740
	je	ck10
	cmp	bp,offset bsingle
	je	ck20
	cmp	bp,offset single
	je	ck30
ck11:	jmp	short cntdn
ck10:	cmp	ch,[ck1k]
	je	ck20
ck15:	mov	bp,offset bsingle
	jmp	short ck50
ck20:	cmp	ch,[ck512]
	je	ck30
ck25:	mov	bp,offset single
	jmp	short ck50
ck30:	cmp	ch,[ck128]
	jne	ck40
	cmp	ch,[ck1k]
	je	ck15
	jmp	short cntdn
ck40:	mov	bp,offset i3740
ck50:	mov	word ptr [makb10+1],bp
cntdn:	dec	si		;retry ctr
	jz	abort		;give up after 5 tries
	mov	ax,di		;error ret code
	cmp	ah,denordy	;time out error?
	jz	abort		;yes - don't retry
	pop	ax		;restore cmd + sec cnt
	jmp	cmdgo		;retry

; abort disk operation and return error status to dos

abort:	mov	ah,0		;reset diskette system
	call	floppy
	xchg	ax,di		;error ret code
	mov	sp,[savsp2]
	pop	es		;restore req hdr
	pop	bx		; from stack
	or	es:byte ptr rhstat[bx],ah	;ret code
	or	es:byte ptr rhstat+1[bx],80h	;error
	mov	es:word ptr count[bx],0	;no secs xfred
	jmp	qdone

;	bp = ptr to bpb (bios parm block)
;	ah = cmd(2=rd 3=wr 4=ver)	al = # of sec
;	(es:bx)	adr of buffer
;	ch = trk # (0-39)		cl = sec # (1-8)
;	dh = head # (0-1)		dl = drv # (0-3)

	assume	ds:abs0

reset:	jmp	short res80
	mov	al,2		;delay 1/8 sec
res60:	xor	cx,cx
res70:	loop	res70		;delay 1/8 sec
	dec	al
	jnz	res60
res80:	mov	dx,3f2h		;adapter control port
	cli
	mov	al,[mostat]	;which motor is on
	mov	cl,4
	sal	al,cl
	test	al,20h
	jnz	res20
	test	al,40h
	jnz	res10
	test	al,80h
	jz	res30
	inc	ax
res10:	inc	ax
res20:	inc	ax
res30:	and	al,[dmask]
	out	dx,al
	or	al,[dmode]	;hs clock
	out	dx,al
	or	al,0ch		;reset off
	out	dx,al
	xor	ax,ax
	mov	[skstat],al
	mov	[dkstat],al
	sti
	mov	cx,14029
res40:	loop	res40		;delay 50 millisec
	xor	dx,dx
	call	ckop
	mov	al,[retstat]
	cmp	al,0c0h
	jnz	genfail
	mov	cx,14029
res50:	loop	res50		;delay 50 millisec

; send specify cmd to 8272

	mov	ah,3
	call	ot8272
	mov	ah,[stepcmd+bp]
	call	ot8272
	mov	ah,2
	call	ot8272
	mov	al,2		;1/4 sec delay
res66:	xor	cx,cx
res68:	loop	res68		;1/8 sec delay
	dec	al
	jnz	res66
	jmp	flopex
res90:	jmp	short reset

floppy	proc	near
	cld			;always up
	push	bx		;save regs
	push	cx
	push	ds
	push	si
	push	di
	push	dx
	mov	cs:[savsp3],sp
	mov	cs:[head],dh
	xor	si,si
	mov	ds,si		;set the data region
	mov	dh,al		;save sector cnt
	and	[mostat],7fh	;clr write delay bit 7
	mov	word ptr [dkstat],si ;clr complete status
	dec	ah
	js	res90		;cmd=0
	dec	ah
	jz	dkread		;cmd=2
	dec	ah
	jz	dkwrite		;cmd=3
	dec	ah
	jz	dkverf		;cmd=4
genfail:mov	ah,defail	;general failure error
	jmp	stoit		;motor off exit
floppy	endp

; diskette verify

dkverf	proc	near
	mov	ax,0a642h	;8272/8237 verify cmds
	jmp	short exec
dkverf	endp

; diskette write

dkwrite	proc	near
	or	mostat,80h	;set wr power on delay
	mov	ax,0854ah	;8272/8237 wr cmds
	jmp	short exec
dkwrite	endp

; diskette read

dkread	proc	near
	mov	ax,0a646h	;8272/8237 rd cmds
dkread	endp

; set up the 8237 dma chip for read/write/verify operations

exec	proc	near
	push	ax		;save 8272 cmd in ah
	cli
	out	12,al		;set the first/last f/f
	push	cx		;i put delay here because
	mov	cl,4		; pc2 proms do?
	out	11,al		;output the mode byte
	mov	ax,es		;xfr segment
	rol	ax,cl
	mov	ch,al		;save h.o. 4 bits segment
	and	al,0f0h		;clr h.o. 4 bits
	add	ax,bx		;add xfr adr to seg/16
	adc	ch,0
	push	ax		;save mem adr
	out	4,al		;low adr to 8237 dma
	mov	al,ah
	out	4,al		;high adr to 8237 dma
	mov	al,ch		;mem adr high 4 bits
	and	al,0fh
	out	81h,al		;high 4 bits to page reg
	mov	al,dh		;num sec to xfr
	cbw
	mov	cl,7
	add	cl,[bp+secszx]	;use as shift cnt (0=128 1=256 etc)
	shl	ax,cl		;multiply by correct amount
	dec	ax		;-1 for dma value
	push	ax		;save the cnt
	out	5,al		;low byte cnt to 8237 dma
	mov	al,ah
	out	5,al		;high byte cnt to 8237 dma
	sti
	pop	cx		;restore cnt
	pop	ax		;restore adr
	add	ax,cx		;ck for 64k overflow
	pop	cx
	mov	al,2		;mode for 8237
	out	10,al
	pop	ax		;restore cmd/sec cnt
	jc	genfail		;64K overflow error
	push	ax		;save cmd/sec cnt

; power on the motor and select the drive

	push	cx		;save trk/sec
	mov	bl,dl		;drive index
	mov	bh,0
	shl	bl,1
	add	bl,[bp+stepcmd]
	mov	cl,dl		;use drive # as shift cnt
	mov	al,1		;motor on bit mask
	sal	al,cl
	mov	dh,al		;save drive mask bit
	push	dx
	cli			;protect from interrupts
	mov	[mocnt],0ffh	;big motor on time
	test	al,[mostat]	;is motor on bit set
	jnz	powon		;motor is already on
	and	[mostat],0f0h	;clr all motor on bits
	or	[mostat],al	;turn on selected motor
	sti
	mov	al,10h		;mask bit 
	sal	al,cl		;bit7-4 = mask for motor on
	or	al,dl		;merge drive #
	and	al,[dmask]
	mov	dx,3f2h		;adapter contol port adr
	out	dx,al
	or	al,[dmode]
	out	dx,al
	or	al,0ch		;enable dma/intr
	out	dx,al		;turn on motor
	test	[mostat],80h	;test for write cmd
	jz	powon		;not write cmd
	mov	al,[bp+moton]	;get the motor on wait
powlp:	xor	cx,cx		;.233 sec loop
	cmp	al,0
	je	powon
powset:	loop	powset
	dec	ax
	jmp	short powlp
powon:	sti
	mov	al,cs:[rate5]
	cmp	bp,offset i3740
	jb	sizset
	mov	al,cs:[rate8]
sizset:	mov	dx,cs:[ioport]	;clock rate sw
	or	dx,dx
	je	nosiz
	out	dx,al

; send specify cmd to set the step rate

nosiz:	pop	dx
	mov	ah,3		;specify cmd
	call	ot8272
	mov	ah,cs:[rates+bx];step rate
	call	ot8272
	mov	ah,2		;hd ld/dma mode
	call	ot8272

; check for drive ready

	xor	cx,cx
drvrdy:	mov	ah,4		;sense drive status
	call	ot8272
	mov	ah,dl		;drive number
	call	ot8272
	call	getstat		;rd the status bytes
	jc	drvext		;error
	test	[retstat],20h	;drive ready/stat reg 3
	jnz	drvext		;drive is ready
	loop	drvrdy		;try again

; do 4 rezero's

drvext:	test	dh,[skstat]	;ck for recal
	jnz	rzex		;no recal needed
	or	[skstat],dh	;turn on the recal bit
	mov	cx,4		;77*4 tracks
rzlp:	mov	ah,7		;8272 recalibrate cmd
	call	ot8272
	mov	ah,dl
	call	ot8272		;drive number
	call	ckop		;wait for intr then sense stat
	jc	rznxt		;seek error on recal
	test	[retstat],10h	;trk zero bit in status reg 3
	jz	rzex		;at trk zero
rznxt:	loop	rzlp
	stc
rzer:	pop	cx
	jmp	short docmd
rzex:	pop	cx

; seek 8272 to desired track

seek:	mov	ah,0fh		;seek cmd to 8272
	call	ot8272
	mov	ah,dl		;drive num
	call	ot8272
	mov	al,[bp+steps]
	mul	ch		;track num
	mov	ah,al
	call	ot8272
	call	ckop		;wait for intr & sense status
	pushf			;save status flag
	mov	al,[bp+settle]	;head settle time
	push	cx
setlp:	mov	cx,550		;1 ms loop
	or	al,al
	jz	setex
setset:	loop	setset		;delay for 1 ms
	dec	ax		;millisec ctr
	jmp	short setlp
setex:	pop	cx
	popf

; perform the transfer operation

docmd:	pop	ax		;restore cmd
	jc	erlink		;seek error
	mov	bh,ah		;save cmd
	or	ah,[bp+mfm]
	call	ot8272		;output the cmd byte to 8272
	mov	ah,cs:[head]	;head num
	push	ax
	sal	ah,1		;move it to bit 2
	sal	ah,1
	and	ah,4
	or	ah,dl		;merge in drive num
	call	ot8272
	mov	ah,ch		;cylinder num
	call	ot8272
	pop	ax		;head num
	call	ot8272
	mov	ah,cl		;sector num
	call	ot8272
	mov	ah,[bp+secszx]	;bytes/sector parm
	call	ot8272
	mov	ah,[bp+sectrk]	;eot parm
	call	ot8272
	mov	ah,[bp+secgap]	;header to sec gap len
	call	ot8272
	mov	ah,0ffh		;dtl parm
	call	ot8272
statlp:	call	waitdone	;wait for the interrupt
	jnc	statx		;no error occurred
erlink:	jmp	erout		;exit after getstat

; read the 8272 status after operation complete

statx:	call	getstat		;fetch 8272 status
	jc	flopex		;error in status read
	mov	si,offset retstat
	mov	al,[si]
	and	al,3
	cmp	al,dl		;drives match
	je	statck
	mov	ah,8		;sense intr status cmd
	call	ot8272
	jmp	statlp
statck:	lodsb			;pick up 1st status byte
	and	al,0c0h		;completion stutus
	jz	sucess		;no error occurred
	cmp	al,40h
	jnz	fail		;invalid cmd

; abnormal termination

	lodsb			;retstat+1
	test	al,80h		;eot found
	jnz	nosec		;sector not found
	test	al,20h		;crc error
	mov	ah,decrc
	jnz	ferror
	test	al,10h		;dma overrun
	jnz	ferror
	test	al,4		;no data
	jnz	nosec
	test	al,2		;write protect
	mov	ah,dewrpro
	jnz	ferror
	test	al,1
nosec:	mov	ah,desec
	jnz	ferror

; 8272 failure occurred

fail:	mov	ah,defail	;rw 8272 failure
ferror:	jmp	short stoit

; operation was successful

sucess:	xor	ah,ah		;no errors
stoit:	mov	[dkstat],ah
flopex:	mov	[mocnt],25h	;set motor timer
	mov	ah,[dkstat]	;completion status
	cmp	ah,1		;set cy flag to indicate
	cmc			; failure if dkstat > 0
	jne	flop20
	dec	ah		;0=write prot er code
flop20:	pop	dx
	pop	di
	pop	si
	pop	ds
	pop	cx
	pop	bx
	ret
exec	endp

; send a byte to the 8272 controller

ot8272	proc	near
	push	dx
	push	cx
	mov	dx,3f4h		;8272 status port
	xor	cx,cx		;time out cnt
lpdir:	in	al,dx		;read 8272 status
	test	al,40h		;test direction bit
	jz	indir		;8272 input mode
	loop	lpdir		;wait for input mode
timout:	mov	[dkstat],denordy ;8272 time out
erout:	mov	sp,cs:[savsp3]
	call	getstat
	jmp	flopex
indir:	xor	cx,cx		;clr timer cnt
lpstat:	in	al,dx		;read 8272 status
	test	al,80h		;is it ready
	jnz	otdat		;8272 ready for xfr
	loop	lpstat		;wait for ready
	jmp	short timout	;error condition
otdat:	mov	al,ah		;output val
	mov	dx,3f5h		;8272 data port
	out	dx,al		;output byte to 8272
	pop	cx
	pop	dx
	ret
ot8272	endp

; read 8272 status

getstat	proc	near
	push	cx
	push	dx
	push	bx
	mov	bl,7		;max status bytes
	mov	di,offset retstat ;pointer to status area
sloop:	xor	cx,cx
	mov	dx,3f4h		;8272 status port adr
srdy:	in	al,dx		;8272 status
	test	al,80h		;request bit
	jnz	sdirck		;master ready
	loop	srdy		;wait for req
	mov	[dkstat],denordy
	jmp	short serror
sdirck:	in	al,dx		;read 8272 status reg
	test	al,40h		;test direction bit
	jz	sfail		;wr mode/status error
	inc	dx		;dx = 8272 data port
	in	al,dx		;read data byte
	mov	[di],al		;save in retstat
	inc	di
	mov	cx,10		;kill time for 8272
sdelay:	loop	sdelay
	dec	dx		;dx = 8272 status port
	in	al,dx		;read 8272 status
	test	al,10h		;test for 8272 busy
	jz	sexit		;8272 not busy
	dec	bl		;status byte ctr
	jnz	sloop
sfail:	mov	[dkstat],defail	;general failure error
serror:	stc			;set error ret
sexit:	pop	bx
	pop	dx
	pop	cx
rexit:	ret
getstat	endp

; wait for the intr after a recal, seek or reset to adapter
; then do a sense interrupt status cmd to fetch 8272 status

ckop	proc	near
	call	waitdone	;wait for done interrupt
	jc	reter		;error occurred
	mov	ah,8		;sense intr status cmd
	call	ot8272
	call	getstat		;read in the status
	jc	reter		;error
	mov	al,[retstat]	;status reg 0
	and	al,3		;isolate drive no
	cmp	al,dl
	jne	ckop		;another's intr
	mov	al,[retstat]	;status reg 0
	and	al,60h
	cmp	al,60h		;ab cmd term + seek end
	jz	seeker		;bad seek
	clc			;ok
reter:	ret
seeker:	mov	[dkstat],deseek
	stc			;error ret code
	ret
ckop	endp

; wait for an interrupt to occur

waitdone proc	near
	sti
	push	ax
	push	cx
	xor	cx,cx		;2 second wait
	mov	al,2
lpdone:	test	[skstat],80h
	jnz	isdone
	loop	lpdone
	dec	al
	jnz	lpdone
	mov	[dkstat],denordy ;time out error
	stc			;error ret code
isdone:	pushf			;save error flag
	and	[skstat],7fh 	;reset intr flag
	popf
	pop	cx
	pop	ax
	ret
waitdone endp

if	($-start) mod 16	;start on paragraph boundary
org	($-start)+16-(($-start) mod 16)
endif
secbufbeg=$
secbuf:				;begin of 1k dma bank crossing buff

; initialize driver, discarded when done

	assume	ds:cseg
init:	mov	cs:[word ptr funtab],offset dummy ;kill init
	lds	si,es:[bx+dword ptr 12h] ;get ds:si=ptr config.sys options
	xor	cx,cx		;cl=#drives, ch=offset
	xor	dx,dx		;dh=flag, dl=last chr
iq10:	lodsb			;scan to end of name
	cmp	al,0Dh		;end of line?
	jz	iq22a		;yes, no options, use default
	call	tvchr		;0 prints as a space
	cmp	al,20h		;end of driver name?
	ja	iq10		;no

;scan for 0, -, D, Q8, Q9, Q89, E, E1, 8, 81, 8k, (1=128, k=1024 sec)
;	DT or QT prev ten-sec formats, A (amlyn), or H (drivetec)
;	G or J type 4

iq20:	lodsb
	cmp	al,0Dh		;cr or lf?
	jbe	iq22a		;yes
	call	tvchr		;chr already uppercase
	cmp	al,';'		;semicoln=comment begins?
	jne	iq22b		;no
iq22a:	jmp	iq90		;yes, end of line
iq22b:	cmp	al,20h		;less than space?
	jbe	iq40		;yes, ignore
	cmp	al,'-'		;-? (unavail drive?)
	jz	iq23		;yes
	cmp	al,30h		;0? =unavail drive?
	jnz	iq25		;no
iq23:	or	cl,cl		;cl must still be 0
	jz	iq24
	jmp	iq90a		;not zero, ignore rest
iq24:	cmp	ch,4		;over max?
	jae	iq82		;yes, ignore rest
	inc	ch		;no, offset+1
	jmp	iq87		;no inc #drives
iq82:	jmp	iq90a
iq25:	cmp	al,'D'		;dual drive?
	jnz	iq29		;no
iq27:	mov	al,0		;al=1=dual (1=quad,2=8")
	jmp short iq81
iq29:	cmp	al,'S'		;single drive?
	jz	iq27		;yes (same as dual)
iq30:	cmp	al,'Q'		;quad?
	jnz	iq33		;no
	mov	al,1		;1=quad
	jmp short iq81
iq33:	cmp	al,'H'		;huge? (drivetec?)
	jz	iq34		;yes
	cmp	al,'A'		;awesome? (amlyn?)
	jnz	iq35		;no
	mov	cs:[word ptr patcha+1],offset awesome
iq34:	mov	al,3		;3=huge/awesome
iq32:	mov	cs:[dmask],03fh
	jmp short iq81
iq35:	cmp	al,'G'
	je	iq36
	cmp	al,'J'
	jne	iq37
	mov	cs:[dmask],3fh
	mov	al,4
	jmp	short iq81
iq36:	mov	al,5
	jmp short iq81
iq37:	cmp	al,'E'		;eight?
	jnz	iq40		;no
iq38:	mov	al,2		;2=eight
	jmp short iq81

; check for drive type modifiers (DO,QT,Q8/9,128,1k patches)

iq40:	cmp	al,'8'		;eight inch/ eight patch?
	jnz	iq45		;no
	cmp	dl,1		;previous Q?
	jnz	iq38		;no, eight inch drive
	or	dh,1		;flag=patch 8
iq44:	jmp	short iq89
iq45:	cmp	al,'9'		;nine patch?
	jnz	iq50		;no
	or	dh,2		;yes
	jmp	short iq89
iq50:	cmp	al,'1'		;128 byte sectors?
	jnz	iq55		;no
	or	dh,4		;yes
	jmp	short iq89
iq55:	cmp	al,'K'		;1024 byte sectors?
	jnz	iq60		;no
	or	dh,8h		;yes
	jmp	short iq89
iq60:	cmp	al,'T'		;old ten format? (big clus?)
	jnz	iq88		;no, all other chrs illegal, ignored
	or	dh,10h		;old ten format (big clus)
	jmp	short iq89
iq81:	mov	ah,cl		;cl=#drives, ch=#offset
	add	ah,ch		;get ah=total drives specd
	cmp	ah,4		;over max?
	jae	iq90a		;yes, ignore rest
	push	ax
	push	bx
	xor	bh,bh
	mov	bl,ah		;bx=index physical drive 0-4
	mov	cs:[bx+offset drvtyp],al ;store type 0,1,2,3,4
	inc	cl		;#drives+1
	add	al,al		;type*2=index to rate
	cbw
	xchg	di,ax		;di=index rates
	mov	ax,word ptr cs:[di+offset ratetab];rate vals for 6,4,3/10,1 ms.
	add	bx,bx		;bx=index*2 (0-6)
	mov	word ptr cs:[bx+offset rates],ax	;store rates
	pop	bx
	pop	ax		;al=drv type
iq87:	inc	di		;point next drive
iq88:	mov	dl,al		;save "previous letter"
iq89:	jmp	iq20		;till line done

;do patch for quads reading 8 and 9, also 128 bytes sectors

iq90a:	mov	al,'e'		;error
	call	tvchr
iq90:	push	cs
	pop	ds		;ds=cs  (es:bx=rq hdr still)
	mov	si,offset msgserial
	call	tvshow
	mov	si,offset serno	;show serial
	call	tvshow
	mov	al,' '
	call	tvchr
	mov	si,offset copyw	;show copyright
	call	tvshow
	mov	al,0Dh		;crlf
	call	tvchr
	mov	al,0Ah
	call	tvchr
	shr	dh,1		;patch 8?
	jnc	iq92		;no
	mov	[byte ptr patch8],74h	;yes, jmp becomes je
iq92:	shr	dh,1		;patch 9?
	jnc	iq94		;no
	mov	[byte ptr patch9],72h	;yes, jmp becomes jb
iq94:	shr	dh,1		;patch 128 byte sects?
	jnc	iq96		;no
	inc	[ck128]		;set 128 byte sec=1
iq96:	shr	dh,1		;patch 1024 byte sects?
	jnc	iq98		;no
	inc	[ck1k]		;yes
iq98:	mov	al,cl		;al=#units
	or	al,al		;0 units?
	jnz	iq99		;no
	cmp	ch,4		;all -'s?
	jae	iq99		;yes
	mov	al,4		;4= default
iq99:	shr	dh,1		;old ten-sec patch?
	jnc	iq120		;no
	mov	[byte ptr tsingle+2],2	;2 sec/clus (1k)
	mov	[byte ptr tsingle+0Bh],1;1 sec each fat table
	mov	[byte ptr edual+2],4	;4 sec/clus (2k clus)
	mov	[byte ptr edual+0Bh],1	;1 sec each fat table
	mov	[byte ptr rquad+2],8	;8 sec/clus (4k clus)
	mov	[byte ptr rquad+0bh],1	;1 sec each fat table

;setup ending address, # units (al), offset (ch), etc.

iq120:	jcxz	iq140
	mov	[nodrv],al		;#units
	mov	[drvoff],ch		;offset (drives to ignore)
iq140:	mov	al,[nodrv]
	mov	es:units[bx],al		;# of units
	mov	bp,offset bpbptr	;ptr to bpb array
	mov	es:bpboff[bx],bp
	mov	es:bpbseg[bx],cs

; setup ending driver addr, adjusted for seg rollover (rare)

	mov	ax,cs			;convert cs to offset
	mov	cl,4
	shl	ax,cl
	add	ax,offset secbuf
	add	ax,1024			;end of secbuf in next bank?
	mov	ax,offset drvend
	jnc	init20			;no
	mov	[bufptr],ax		;yes, relocate secbuf
	add	ax,1024			;new end of buffer
init20:	shr	ax,cl			;convert cs to seg
	mov	dx,cs
	add	dx,ax
	mov	word ptr es:bradr0[bx],0;ending offset=0
	mov	es:bradr1[bx],dx	;ending segment
	jmp	qexit			;done

;  output al=chr to tvscreen

tvproc	proc	near
tvchr:	push	ax
	push	dx
	xor	dx,dx		;dh=0=output mode
	or	al,al		;0? (expand to a space)
	jnz	tvc15		;no
	mov	al,' '
tvc15:	mov	dl,al		;dl=chr
	mov	ah,6		;direct console i/o
	int	21h
	pop	dx
	pop	ax
	ret

;  display line si=ptr , ends with 0

tvshow:	push	ax
tv10:	lodsb			;get chr
	or	al,al		;0=end of str?
	jz	tv90		;yes
	call	tvchr
	jmp	short tv10	;till end
tv90:	pop	ax
	ret
msgserial	db	'  Ver 2.50 Ser.',0
tvproc	endp

begsp = secbufbeg+1024+256	;1k for dma buff, 256 bytes stack
drvend = begsp
qdrive	endp
cseg	ends
	end	begin
